#ifndef	ICI_RE_H
#define	ICI_RE_H

/*
 * Definitions etc. for regexp(3) routines.
 *
 * Caveat:  this is V8 regexp(3) [actually, a reimplementation thereof],
 * not the System V one.
 */
#define NSUBEXP  10
typedef struct regexp {
	char *startp[NSUBEXP];
	char *endp[NSUBEXP];
	char regstart;		/* Internal use only. */
	char reganch;		/* Internal use only. */
	char *regmust;		/* Internal use only. */
	int regmlen;		/* Internal use only. */
	int size;		/* Internal use only. */
	char program[1];	/* Unwarranted chumminess with compiler. */
} regexp;

#if __STDC__ == 1
regexp *regcomp(char *);
int regexec(regexp *, char *);
void regsub(regexp *, char *, char *);
void regerror(char *);
#else
extern regexp *regcomp();
extern int regexec();
extern void regsub();
extern void regerror();
#endif

#ifndef	ICI_OBJECT_H
#include "object.h"
#endif

struct regexpo
{
    object_t	o_head;
    regexp	*r_re;
};
#define	regexpof(o)	((regexp_t *)(o))
#define	isregexp(o)	((o)->o_tcode == TC_REGEXP)

extern int *re_nbra;

#endif
